#include "stg/user_property.h"

STG::UserProperties::UserProperties(const Settings& s)
    : cash            (stat.cash,             "cash",             false, true, s, properties),
      up              (stat.monthUp,          "upload",           false, true, s, properties),
      down            (stat.monthDown,        "download",         false, true, s, properties),
      lastCashAdd     (stat.lastCashAdd,      "lastCashAdd",      false, true, s, properties),
      passiveTime     (stat.passiveTime,      "passiveTime",      false, true, s, properties),
      lastCashAddTime (stat.lastCashAddTime,  "lastCashAddTime",  false, true, s, properties),
      freeMb          (stat.freeMb,           "freeMb",           false, true, s, properties),
      lastActivityTime(stat.lastActivityTime, "lastActivityTime", false, true, s, properties),

      password    (conf.password,     "password",     true,  false, s, properties),
      passive     (conf.passive,      "passive",      false, false, s, properties),
      disabled    (conf.disabled,     "disabled",     false, false, s, properties),
      disabledDetailStat(conf.disabledDetailStat, "DisabledDetailStat", false, false, s, properties),
      alwaysOnline(conf.alwaysOnline, "alwaysOnline", false, false, s, properties),
      tariffName  (conf.tariffName,   "tariffName",   false, false, s, properties),
      nextTariff  (conf.nextTariff,   "nextTariff",   false, false, s, properties),
      address     (conf.address,      "address",      false, false, s, properties),
      note        (conf.note,         "note",         false, false, s, properties),
      group       (conf.group,        "group",        false, false, s, properties),
      email       (conf.email,        "email",        false, false, s, properties),
      phone       (conf.phone,        "phone",        false, false, s, properties),
      realName    (conf.realName,     "realName",     false, false, s, properties),
      credit      (conf.credit,       "credit",       false, false, s, properties),
      creditExpire(conf.creditExpire, "creditExpire", false, false, s, properties),
      ips         (conf.ips,          "ips",          false, false, s, properties),
      userdata0   (conf.userdata[0],  "userdata0",    false, false, s, properties),
      userdata1   (conf.userdata[1],  "userdata1",    false, false, s, properties),
      userdata2   (conf.userdata[2],  "userdata2",    false, false, s, properties),
      userdata3   (conf.userdata[3],  "userdata3",    false, false, s, properties),
      userdata4   (conf.userdata[4],  "userdata4",    false, false, s, properties),
      userdata5   (conf.userdata[5],  "userdata5",    false, false, s, properties),
      userdata6   (conf.userdata[6],  "userdata6",    false, false, s, properties),
      userdata7   (conf.userdata[7],  "userdata7",    false, false, s, properties),
      userdata8   (conf.userdata[8],  "userdata8",    false, false, s, properties),
      userdata9   (conf.userdata[9],  "userdata9",    false, false, s, properties)
{}
